(function (Drupal, once) {
  Drupal.behaviors.simpleCarousel = {
    attach: function (context, settings) {
      // Find all carousels within the context
      const carousels = once('simple-carousel', '.simple-carousel', context);

      carousels.forEach(carousel => {
        const list = carousel.querySelector(".simple-carousel-inner");
        const items = carousel.querySelectorAll(".simple-carousel-item");
        if (items.length === 0) {
          return; // Skip if there are no items
        }
        const itemWidth = items[0].offsetWidth;

        const prevButtons = once('simple-carousel-button', carousel.querySelectorAll(".button--previous a"));
        const nextButtons = once('simple-carousel-button', carousel.querySelectorAll(".button--next a"));

        prevButtons.forEach(button => {
          button.addEventListener("click", function() {
            if (list.scrollLeft === 0) {
              // Scroll to the end
              list.scrollTo({ left: list.scrollWidth, behavior: "smooth" });
            } else {
              list.scrollBy({ left: -itemWidth, behavior: "smooth" });
            }
          });
        });

        nextButtons.forEach(button => {
          button.addEventListener("click", function() {
            if (list.scrollLeft + list.offsetWidth >= list.scrollWidth) {
              // Scroll back to the beginning
              list.scrollTo({ left: 0, behavior: "smooth" });
            } else {
              list.scrollBy({ left: itemWidth, behavior: "smooth" });
            }
          });
        });
      });
    }
  };
})(Drupal, once);
